Attribute VB_Name = "Sample"
'*****************************************************************************
'* aisa35s.bas                                                               *
'*                                                                           *
'* aISA-A35                                                              *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'* Date 1998/03/11                                                           *
'*                                                                           *
'*  ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B                   *
'*                                                                           *
'*****************************************************************************
Option Explicit

Private Const szTitle = "Sample"
Private Const szA35 = "aISA-A35"
Private Declare Function GetLastError Lib "kernel32" () As Long


Sub Main()

    Dim strbuf As String
    Dim dwDllVer As Long, dwDrvVer As Long
    Dim bResult As Boolean              ' 
    Dim wLogSlot As Integer             ' foCXi[
    Dim b As Byte
    Dim ri As AISA35RESOURCE            ' \[X
    Dim param As AISA35PARA             ' TvOp[^
    Dim wSmpData As Integer             ' TvOf[^

'---------------------------------------------------------------------------
    ' aisa35.dll ̎gp錾
    If Aisa35wDllOpen() = False Then
        ErrorMessage (AISA35_SLOT_AUTO)
        Exit Sub                ' aisa35.dll ̃[hɎs܂
    End If

'---------------------------------------------------------------------------
    ' o[Wԍ\
    If Aisa35wGetVersion(dwDllVer, dwDrvVer) = False Then ' aISA-A35DLL,Drṽo[Wԍ擾
        ErrorMessage (AISA35_SLOT_AUTO)
        Exit Sub
    End If

    strbuf = "GetVersion" + Chr(10) + _
             "DLL Version: &H" + Hex(dwDllVer) + Chr(10) + _
             "Drv Version: &H" + Hex(dwDrvVer)
    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' aISA-A35̎gp錾
    wLogSlot = AISA35_SLOT_AUTO     ' gp̃foCXT܂B

    ' ꍇA̎̃foCXi[܂B
    bResult = Aisa35wCreate(wLogSlot)

    If bResult = False Then         ' foCX܂B
        ErrorMessage (AISA35_SLOT_AUTO)
        Exit Sub
    End If

    strbuf = "aISA-A35 Created" + Chr(10) + Chr(10) + _
          "LogSlot: " + Str(wLogSlot)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' \[X擾
    If Aisa35wGetResource(wLogSlot, ri) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "Board Name: " + szA35 + Chr(10) + _
             "NumPorts: " + Str(ri.dwIOPortLength(1)) + Chr(10) + _
             "IO Address: &H" + Hex(ri.dwIOPortBase(1)) + _
             "-&H" + Hex(ri.dwIOPortBase(1) + ri.dwIOPortLength(1) - 1)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' TvO
    param.dwSamplingChannel = 1     ' TvOs`l (1`8)
    param.dwResolution = 12         ' \(8 or 12 bits)

    If Aisa35wStartSampling(wLogSlot, param, wSmpData) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "TvOf[^" + Chr(10) + _
             "Data: &H" + Hex(wSmpData)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' Cӂ̃f[^o
    ' &HAA -> 10101010
    b = &HAA

    If Aisa35wOutPort(wLogSlot, b) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "f[^o" + Chr(10) + _
             "Out Data: &H" + Hex(b)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' f[^ǂݍ
    b = &H0

    If Aisa35wInPort(wLogSlot, b) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "f[^" + Chr(10) + _
             "In Data: &H" + Hex(b)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' aISA-A35̎gpJ
    If Aisa35wClose(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ResultMessage ("aISA-A35 Closed")

'---------------------------------------------------------------------------
    ' aisa35.dll ̎gpJ
    If Aisa35wDllClose() = False Then
        MsgBox "DLL ̃A[hɎs܂B", vbOKOnly + vbCritical
        Exit Sub        ' aisa35.dll ̃A[hɎs܂B
    End If

End Sub

' ʂ\
Private Sub ResultMessage(lpszbuf As String)

    MsgBox lpszbuf, vbOKOnly + vbInformation

End Sub


' G[bZ[W\
Private Sub ErrorMessage(wLogSlot As Integer)

    Dim dwRes As Integer
    Dim szbuf As String

    dwRes = Aisa35wGetLastError(wLogSlot)

    Select Case dwRes
    Case AISA35_ERR_SYSTEM
        szbuf = "System error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(GetLastError())

    Case AISA35_ERR_WRAPDLL
        szbuf = "DLL Load error"

    Case Else
        szbuf = "aISA-A35 error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(dwRes)
    End Select

    MsgBox szbuf, vbOKOnly + vbCritical

End Sub
