/*****************************************************************************/
/*	aisa35w.c																 */
/*																			 */
/*	aISA-A35															 */
/*																			 */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									 */
/*																			 */
/*	Date 1998/08/17															 */
/*																			 */
/*****************************************************************************/

#include <windows.h>
#include <tchar.h>

#include "aisa35w.h"	// aISA-A35

/*---------- X^eBbN֐ -----------------------------------------------*/
static BOOL Aisa35wGetDllExportFunc();


/*---------- X^eBbNϐ(萔) -----------------------------------------*/
static HMODULE hDLL = NULL;

// DLL GNX|[g֐AhX̊i[ϐ
static FARPROC pAisa35GetVersion;
static FARPROC pAisa35Create;
static FARPROC pAisa35Close;
static FARPROC pAisa35GetResource;
static FARPROC pAisa35StartSampling;
static FARPROC pAisa35InPort;
static FARPROC pAisa35OutPort;
static FARPROC pAisa35GetLastError;


/*****************************************************************************/
/* 	  aisa35.dll[h												 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa35wDllOpen()
{
	if (hDLL != NULL)
		return FALSE;

	hDLL = (HMODULE)LoadLibrary(AISA35_DLL_NAME);
	if (hDLL == NULL)
		return FALSE;

	if (Aisa35wGetDllExportFunc() == FALSE)
	{
		Aisa35wDllClose();	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		return FALSE;
	}

	return TRUE;
}

/*****************************************************************************/
/* 	  aisa35.dllA[h											 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa35wDllClose()
{
	if (hDLL == NULL)
		return TRUE;

	if (FreeLibrary(hDLL) == TRUE)
	{
		hDLL = NULL;
		return TRUE;
	}

	return FALSE;
}

/*****************************************************************************/
/* 	  aISA-A35 DLL,Drṽo[Wԍ擾								 */
/* 	  pdwDllVer DLL	  o[Wԍi[AhX					 */
/*		  pdwDrvVer Drivero[Wԍi[AhX					 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa35wGetVersion(PDWORD pdwDllVer, PDWORD pdwDrvVer)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa35GetVersion)(pdwDllVer, pdwDrvVer);
}

/*****************************************************************************/
/* 	  aISA-A35̔Cӂ̃foCX̎gp錾								 */
/* 	  pwLogSlot	 gpfoCXi[AhX						 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa35wCreate(PWORD pwLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa35Create)(pwLogSlot);
}

/*****************************************************************************/
/* 	  aISA-A35̔Cӂ̃foCX̎gpJ								 */
/* 	  wLogSlot gpfoCX											 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa35wClose(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa35Close)(wLogSlot);
}

/*****************************************************************************/
/* 	  wfoCX̃\[X擾									 */
/* 	  wLogSlot ׂfoCX											 */
/*		  pres	   \[Xi[\̂̃AhX					 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa35wGetResource(WORD wLogSlot, PAISA35R pres)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa35GetResource)(wLogSlot, pres);
}

/*****************************************************************************/
/* 	  A/DTvO̎s												 */
/* 	  wLogSlot		 TvOfoCX							 */
/*		  pcpara		 TvOp[^								 */
/*		  pwSamplingData TvOf[^									 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa35wStartSampling(WORD wLogSlot, PAISA35P pcpara, PWORD pwSamplingData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa35StartSampling)(wLogSlot, pcpara, pwSamplingData);
}

/*****************************************************************************/
/* 	  Cӂ̃|[gf[^										 */
/* 	  wLogSlot	͂foCX										 */
/*		  pbInValue ̓f[^i[AhX							 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa35wInPort(WORD wLogSlot, PBYTE pbInValue)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa35InPort)(wLogSlot, pbInValue);
}

/*****************************************************************************/
/* 	  Cӂ̃|[gփf[^o										 */
/* 	  wLogSlot	o͂foCX										 */
/*		  bOutValue o͂f[^											 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa35wOutPort(WORD wLogSlot, BYTE bOutValue)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa35OutPort)(wLogSlot, bOutValue);
}

/*****************************************************************************/
/* 	  aISA-A35̃G[R[h											 */
/* 	  wLogSlot	G[foCX								 */
/* ߂l G[R[h														 */
/*****************************************************************************/
DWORD Aisa35wGetLastError(WORD wLogSlot)
{
	if (hDLL == NULL)
		return AISA35_ERR_WRAPDLL;

	return (*pAisa35GetLastError)(wLogSlot);
}

/*---------------------------------------------------------------------------*/
/* 	  DLLGNX|[g֐AhX̎擾									 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*---------------------------------------------------------------------------*/
static BOOL Aisa35wGetDllExportFunc()
{
	// Aisa35GetVersion ̃AhX擾
	pAisa35GetVersion = GetProcAddress(hDLL, _T("Aisa35GetVersion"));
	if (pAisa35GetVersion == NULL)
		return FALSE;

	// Aisa35Create ̃AhX擾
	pAisa35Create = GetProcAddress(hDLL, _T("Aisa35Create"));
	if (pAisa35Create == NULL)
		return FALSE;

	// Aisa35Close ̃AhX擾
	pAisa35Close = GetProcAddress(hDLL, _T("Aisa35Close"));
	if (pAisa35Close == NULL)
		return FALSE;

	// Aisa35GetResource ̃AhX擾
	pAisa35GetResource = GetProcAddress(hDLL, _T("Aisa35GetResource"));
	if (pAisa35GetResource == NULL)
		return FALSE;

	// Aisa35StartSampling ̃AhX擾
	pAisa35StartSampling = GetProcAddress(hDLL, _T("Aisa35StartSampling"));
	if (pAisa35StartSampling == NULL)
		return FALSE;

	// Aisa35InPort ̃AhX擾
	pAisa35InPort = GetProcAddress(hDLL, _T("Aisa35InPort"));
	if (pAisa35InPort == NULL)
		return FALSE;

	// Aisa35OutPort ̃AhX擾
	pAisa35OutPort = GetProcAddress(hDLL, _T("Aisa35OutPort"));
	if (pAisa35OutPort == NULL)
		return FALSE;

	// Aisa35GetLastError ̃AhX擾
	pAisa35GetLastError = GetProcAddress(hDLL, _T("Aisa35GetLastError"));
	if (pAisa35GetLastError == NULL)
		return FALSE;

	return TRUE;	// SĂ DLL GNX|[g֐AhX擾
}
